"use strict";

exports.__esModule = true;
exports.default = _default;

function filterComments(list, path, _remove) {
  return list.filter(function (o) {
    return o.type.toLowerCase() !== _remove;
  });
}

function getRemoveType(remove) {
  if (remove === 'all') return 'all';
  if (remove === 'block' || remove.toLowerCase() === 'commentblock') return 'commentblock';
  if (remove === 'line' || remove.toLowerCase() === 'commentline') return 'commentline';
  throw new Error("The 'remove' option must be undefiend, 'none', 'all', 'block', or 'line'.");
}

function _default(_ref) {
  var t = _ref.types;
  return {
    name: 'remove-comments',
    visitor: {
      Program: function Program(path, _temp) {
        var _ref2 = _temp === void 0 ? {} : _temp,
            _ref2$opts$remove = _ref2.opts.remove,
            remove = _ref2$opts$remove === void 0 ? 'none' : _ref2$opts$remove;

        if (remove === 'none') return;

        var _remove = getRemoveType(remove);

        path.traverse({
          enter: function enter(path) {
            var leadingCommentsList = path.node.leadingComments || [];
            var trailingCommentsList = path.node.trailingComments || [];

            if (leadingCommentsList.length > 0 || trailingCommentsList.length > 0) {
              if (_remove === 'all') {
                t.removeComments(path.node);
              } else {
                path.node.leadingComments = filterComments(leadingCommentsList, path, _remove);
                path.node.trailingComments = filterComments(trailingCommentsList, path, _remove);
              }
            }
          }
        });
      }
    }
  };
}